/*==============================================================================
   DEMO.C :- DOC to RTF Converter demo Program
   Sub Systems, Inc.
   Software License Agreement  (1998)
   ----------------------------------
   This is a demo program.  
===============================================================================*/
#define  STRICT

#include "windows.h"
#if defined (_WIN32)
   #if !defined(WIN32)
     #define WIN32
   #endif
#endif
#if !defined(WIN32)
  #include "print.h"
  #if defined (__TURBOC__)
    typedef unsigned short USHORT;     // missing in compiler
  #endif
#endif

#include "stdio.h"
#include "stdlib.h"
#include "fcntl.h"
#include "sys\types.h"
#include "sys\stat.h"
#include "io.h"
#include "string.h"

#include "commdlg.h"

/******************************************************************************
    WIN32 specific defines
*******************************************************************************/
#undef  huge
#define huge
#undef  FreeProcInstance
#define FreeProcInstance(x)
#define GET_WM_COMMAND_ID(wp,lp) LOWORD(wp)
#define NOTIFY_MSG(wp,lp)        HIWORD(wp)
#define farmalloc  malloc
#define farrealloc realloc
#define farfree    free

#define true       TRUE
#define false      FALSE
#define null       NULL

#include "whs.h"

#include "demo.h"

/****************************************************************************
   Main Windows Routine
****************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
    MSG msg;
    int i;

    if (DoCmdLine(lpCmdLine)) return 0;        // 20071220: process the command line

    #ifndef WIN32
      int QueueLength=96;
      while (!SetMessageQueue(QueueLength) && (QueueLength-=8));
    #endif

    SetMessageQueue(96);   // needed for OLE2

    lpDemoDlg = MakeProcInstance((FARPROC)DemoDlg, hInst);
    
    DialogBoxParam(hInstance,"DemoDlg",NULL,(DLGPROC)lpDemoDlg,0);

    FreeProcInstance((FARPROC)lpDemoDlg);       // free the dialog box

    return 0;//(msg.wParam);
}

/****************************************************************************
    DoCmdLine:
    Process the command line.
****************************************************************************/
BOOL DoCmdLine(LPBYTE CmdLine)
{
    BYTE InFile[300],OutFile[300],key[100]="",nbr[100]="",company[100]="",flags[100]="";
    int  i,flag,count;
    DWORD id;
    BOOL  result=false;

    if (lstrlen(CmdLine)==0) return FALSE;         // do interactive operation

    count=sscanf(CmdLine,"%s %s %s %s %s %s",InFile,OutFile,key,nbr,company,flags);

    if (count!=2 && count>6) {
       printf("Usage: \n\n");
       printf("   DEMO in-file.rtf out-file.pdf\n\n");
       printf("   or,\n\n");
       printf("   DEMO in-file.rtf out-file.pdf LicenseKey LicenseNbr CompanyName\n\n");
       printf("   or,\n\n");
       printf("   DEMO in-file.rtf out-file.pdf LicenseKey LicenseNbr CompanyName flags\n\n");  // each flag is one word, multiple flags are delimited by a * character
       return TRUE;
    } 
    
    if (count>=5 && lstrcmpi(key,"eval")!=0) WhsSetLicenseInfo(key,nbr,company);    // to eval set, the licensekey,license number and company name to eval, eval, eval
      
    id=WhsNewSession();   // begin a conversion session

    WhsSetFlags(id,TRUE,WHFLAG_LIST_TO_TEXT);         // save lists as simple text to html for accurate list structure output

    if (count>=6 && strstr(flags,"in-server")!=null) WhsSetFlags(id,TRUE,WHFLAG_RETURN_MSG_ID);   // set for server

    if (WhsConvertFile(id,InFile,OutFile)) printf("Done!\n");
    else printf("Error!\n");

    WhsEndSession(id);   // end conversion session

    return TRUE;
} 


/****************************************************************************
    DemoDlg:
    Display the dialog box.
****************************************************************************/
int FAR PASCAL _export DemoDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    BYTE InFile[300],OutFile[300];
    int  i;
    DWORD id;
    BOOL  result=false;

    switch (message) {
        case WM_INITDIALOG:
            // initialize the radion button
            SendDlgItemMessage(hDlg,IDC_HTML_TO_RTF,BM_SETCHECK,1,0L);
            return (FALSE);

        case WM_COMMAND:
            switch (GET_WM_COMMAND_ID(wParam,lParam)) {
                case IDC_PURCHASE:
                   ShellExecute(hDlg,"open","http://www.subsystems.com/dhw.htm",NULL,NULL,0);

                   break;

                case IDOK:
                   SetDlgItemText(hDlg,IDC_STATUS,"");

                   GetDlgItemText(hDlg,IDC_INPUT_FILE,InFile,sizeof(InFile)-1);
                   GetDlgItemText(hDlg,IDC_OUTPUT_FILE,OutFile,sizeof(OutFile)-1);

                   // check the file names
                   if (lstrlen(InFile)==0) {
                      MessageBeep(0);
                      SetFocus(GetDlgItem(hDlg,IDC_INPUT_FILE));
                      return true;
                   } 
                   if (lstrlen(OutFile)==0) {
                      MessageBeep(0);
                      SetFocus(GetDlgItem(hDlg,IDC_OUTPUT_FILE));
                      return true;
                   } 


                   SetDlgItemText(hDlg,IDC_STATUS,"Converting...");
                   
                   // do the conversion
                   id=WhsNewSession();   // begin a conversion session

                   //WhsSetFlags(id,TRUE,WHFLAG_NO_SPAN_TAG);          // do not generate the span tag
                   //WhsSetFlags(id,TRUE,WHFLAG_NO_FONT);              // do not generate the font tag
                   //WhsSetFlags(id,TRUE,WHFLAG_FLASH_SUPPORT);        // tailor output for Flash support
                   //WhsSetFlags(id,TRUE,WHFLAG_RETURN_MSG_ID);        // return a message id instead of displaying an error message
                   //WhsSetFlags(id,TRUE,WHFLAG_SEGMENT_ONLY);         // skip header and body tags
                   //WhsSetFlags(id,TRUE,WHFLAG_XLATE_SINGLE_QUOTE);   // Write the single quote characters as &#39; to the html output
                   //WhsSetFlags(id,TRUE,WHFLAG_SAVE_PICT_AS_BMP);     // Generates picture as bmp in html output
                   //WhsSetFlags(id,TRUE,WHFLAG_PNG_RGB);              // save PNG pictures in RGB (high quality)
                   //WhsSetFlags(id,TRUE,WHFLAG_FIX_NEG_INDENT);       // fix negative indent during docx read
                   //WhsSetFlags(id,TRUE,WHFLAG_INPUT_FIELD_TO_TEXT_BOX); // convert the input fields to text boxes
                   
                   WhsSetFlags(id,TRUE,WHFLAG_LIST_TO_TEXT);           // save lists as simple text to html for accurate list structure output

                   //WhsSetPaperSize(id,DMPAPER_LEGAL,0,0);            // set paper size for html output
                   //WhsSetPaperOrient(id,DMORIENT_LANDSCAPE);         // set paper orientation for html output
                   //WhsSetPageMargin(id,3000,3000,3000,3000);         // set page margin - values specified in twips (1440 twips = 1 inch)
                   
                   //WhsSetDownloadDir(id,"c:\\temp");                // set the directory where the picture files will be created, or where the temporary internet picture files will be downloaded
                   //WhsSetHtmlDocTitle(id,"My Title");                 // set the title tag content for the html output


                   if ((BOOL)SendDlgItemMessage(hDlg,IDC_USE_BUFFER,BM_GETCHECK,0,0L)) {  // read the file in the memory buffer and do the conversion
                       HGLOBAL hMem;
                       int InSize,OutSize;
                       LPBYTE pInData;
                       
                       pInData=ReadFromFile(InFile,&InSize);
                       if (pInData!=null && (hMem=WhsConvertBuffer(id,pInData,InSize,&OutSize))) {
                           if (WriteToFile(OutFile,hMem,OutSize)) { // write the memory to the output file   
                              result=true;
                              SetFocus(GetDlgItem(hDlg,IDC_INPUT_FILE));   // ask for the next file
                           }
                       }
                       MemFree(pInData);
                   }
                   else {      // convert files directly
                       if (WhsConvertFile(id,InFile,OutFile)) {
                           result=true;
                           SetFocus(GetDlgItem(hDlg,IDC_INPUT_FILE));   // ask for the next file
                       }
                   }
                   
                   SetDlgItemText(hDlg,IDC_STATUS,result?"Done!":"Error!");
                   WhsEndSession(id);   // end conversion session

                   if (result) ShellExecute(hDlg,"open",OutFile,NULL,NULL,SW_SHOW);   // invoke Acrobat to show the test file

                   break;

                case IDCANCEL:
                   EndDialog(hDlg, FALSE);
                   ProcessMsg=FALSE;
                   return (TRUE);
                default:
                   ;
            }
            break;
    }
    return (FALSE);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////// Helper functions
////////////////////////////////////////////////////////////////////////////////////////////////////////////

/******************************************************************************
    ReadFromFile:
    Read the contents of a file into a memory buffer
 ******************************************************************************/
LPBYTE ReadFromFile(LPBYTE InFile, LPINT InSize)
{
    HANDLE hFile=INVALID_HANDLE_VALUE;
    long size=0;
    DWORD BytesRead;
    LPBYTE pMem=NULL;

    hFile=CreateFile(InFile,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    if (hFile!=INVALID_HANDLE_VALUE) {
       size=SetFilePointer(hFile,0,NULL,FILE_END); 
       SetFilePointer(hFile,0,NULL,FILE_BEGIN);
       if (NULL!=(pMem=MemAlloc(size+1))) {
           ReadFile(hFile,pMem,size,&BytesRead,NULL);
           if (size!=(long)BytesRead) return FALSE;
       }
       CloseHandle(hFile);
    }
    else MessageBox(NULL,"Error opening the input file",NULL,MB_OK);

    (*InSize)=(int)size;

    return pMem;
}

/******************************************************************************
    WriteToFile:
    Write the data to the disk file
 ******************************************************************************/
BOOL WriteToFile(LPBYTE OutFile, HGLOBAL hMem, int InSize)
{
    HANDLE hFile;
    OFSTRUCT OpenBuf;
    LPBYTE pMem;
    int BytesWritten;

    unlink(OutFile);
    if (INVALID_HANDLE_VALUE==(hFile=CreateFile(OutFile,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL))) {
       MessageBox(NULL,"Error opening the output file",NULL,MB_OK);
       return false;
    }

    pMem=GlobalLock(hMem);

   if (!WriteFile(hFile,pMem,InSize,&((DWORD)BytesWritten),NULL) 
           || BytesWritten!=InSize) {
       MessageBox(NULL,"Error writing to the output file",NULL,MB_OK);
       return false;
    } 

    GlobalUnlock(hMem);
    GlobalFree(hMem);

    CloseHandle(hFile);             // close file

    return TRUE;
} 

/******************************************************************************
    MemAlloc:
    This function simply allocates using the runtime library
*******************************************************************************/
void far *MemAlloc(UINT size)
{
    void far *ptr;

    if (NULL==(ptr=farmalloc(size+1))) MessageBox(NULL,"Error allocating memory",NULL,MB_OK);

    return ptr;
}

/******************************************************************************
    MemReAlloc:
    This function simply reallocates using the runtime library
*******************************************************************************/
void far *MemReAlloc(void far *InPtr,UINT size)
{
    void far *ptr;

    if (NULL==(ptr=farrealloc(InPtr,size+1))) MessageBox(NULL,"Error allocating memory",NULL,MB_OK);

    return ptr;
}

/******************************************************************************
    MemFree:
    This function simply frees a runtime library allocated memory block
*******************************************************************************/
int MemFree(void far *ptr)
{
   if (ptr) farfree(ptr);

   return TRUE;
}
 
/******************************************************************************
    OurPrintf:
    This routine formats and display a given set of arguments.  The format
    is given by the first argument.  The argument 2 to n contain the
    arguments for the specified format.  The function uses MessageBox to
    display the formatted string.
******************************************************************************/
int OurPrintf(LPSTR fmt,...)
{
    LPSTR ArgStart;
    char string[300];
    HWND hWnd;

    ArgStart=(LPSTR) &fmt;  // pointer to first argument
    ArgStart=&ArgStart[4];  // go past the first argument
    wvsprintf(string,fmt,ArgStart);

    if (NULL!=(hWnd=FindWindow("DBWin",NULL))) { // debug window open
        if (NULL!=(hWnd=GetWindow(hWnd,GW_CHILD))) {    // get the edit window
           int len=lstrlen(string);
           string[len]=0xd;
           string[len+1]=0xa;
           string[len+2]=0;
           #if defined (WIN32)
              SendMessage(hWnd,EM_SETSEL,32767,32767);  // show the last line
              SendMessage(hWnd,EM_REPLACESEL,0,(DWORD)(LPSTR)string);
              SendMessage(hWnd,EM_SCROLLCARET,0,0);     // scroll caret into view
           #else
              SendMessage(hWnd,EM_SETSEL,0,MAKELPARAM(32767,32767));  // show the last line
              SendMessage(hWnd,EM_REPLACESEL,0,(DWORD)(LPSTR)string);
              SendMessage(hWnd,EM_SETSEL,0,MAKELPARAM(32767,32767));  // show the last line
           #endif
        }
    }
    else MessageBox(NULL,string,NULL,MB_OK);
    return TRUE;
}


/****************************************************************************
                      DEMO DIALOG PROCEDURES
****************************************************************************/


